/* $Id: ast_ehandlers.cpp 6310 2023-01-16 20:39:48Z aron $ */
/*
    Welltype parser and AST
    Copyright (C) 2014-2023  Aron Barath

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "ast_ehandlers.h"
#include "ast_ehandler.h"
#include "../astvisitor.h"

wtast::EHandlers::~EHandlers()
{
	while(!mEHandlers.empty())
	{
		delete mEHandlers.front();
		mEHandlers.pop_front();
	}
}

void wtast::EHandlers::Accept(AstVisitor* vis)
{
	if(vis->Visit(this))
	{
		for(ehandlers_t::iterator it=mEHandlers.begin(),end=mEHandlers.end();it!=end;++it)
		{
			(*it)->Accept(vis);
		}

		vis->EndVisit(this);
	}
}

wtast::EHandlers* wtast::EHandlers::Copy()
{
	ehandlers_t ehs;

	for(ehandlers_t::iterator it=mEHandlers.begin(),end=mEHandlers.end();it!=end;++it)
	{
		ehs.push_back((*it)->Copy());
	}

	return new EHandlers(ehs.begin(), ehs.end());
}

