#ifndef WTRUNTIME_CONVERT_H
#define WTRUNTIME_CONVERT_H

#include "config.h"
#include "types.h"

/*
	Instructions:
	-------------

		'from string'
			gv:  store the converted number in
			str: holds the string to convert
			returns status code (zero on success)

		'to string'
			value:      number to convert
			begin, end: defines a writeable buffer
			returns a pointer (within [begin,end) range) to the start of the result
*/

int wtr_convert_str_to_i32(union wtr_genvalue* const gv, const char* str);
char* wtr_convert_i32_to_str(union wtr_genvalue gv, char* begin, char* end);

int wtr_convert_str_to_u32(union wtr_genvalue* const gv, const char* str);
char* wtr_convert_u32_to_str(union wtr_genvalue gv, char* begin, char* end);

int wtr_convert_str_to_i64(union wtr_genvalue* const gv, const char* str);
char* wtr_convert_i64_to_str(union wtr_genvalue gv, char* begin, char* end);

int wtr_convert_str_to_u64(union wtr_genvalue* const gv, const char* str);
char* wtr_convert_u64_to_str(union wtr_genvalue gv, char* begin, char* end);

#if WTRUNTIME_ENABLE_FLOAT32

int wtr_convert_str_to_f32(union wtr_genvalue* const gv, const char* str);
char* wtr_convert_f32_to_str(union wtr_genvalue gv, char* begin, char* end);

#endif /* WTRUNTIME_ENABLE_FLOAT32 */

#if WTRUNTIME_ENABLE_FLOAT64

int wtr_convert_str_to_f64(union wtr_genvalue* const gv, const char* str);
char* wtr_convert_f64_to_str(union wtr_genvalue gv, char* begin, char* end);

#endif /* WTRUNTIME_ENABLE_FLOAT64 */

int wtr_convert_str_to_bool(union wtr_genvalue* const gv, const char* str);
char* wtr_convert_bool_to_str(union wtr_genvalue gv, char* begin, char* end);

#endif /* WTRUNTIME_CONVERT_H */
