#include "config_private.h"
#include "symtab.h"
#include "sym.h"
#include "vector.h"
#include "vm.h"
#include <string.h>

void wtr_symtab_symvec_destroy(struct wtr_vm* const vm,
	struct wtr_vector* const symvec)
{
	const size_t num_syms = wtr_vector_size(symvec);

	if(0<num_syms)
	{
		struct wtr_sym** syms = (struct wtr_sym**)wtr_vector_at(symvec, 0);

		struct wtr_sym** const end = syms + num_syms;

		while(syms<end)
		{
			struct wtr_sym* const sym = *syms++;

			if(NULL!=sym)
			{
				wtr_sym_unreg_gid(vm, sym);
				wtr_sym_release(vm, sym);
			}
		}
	}

	wtr_vector_delete(symvec, vm);
}
